/* Petit programme pour afficher une VALEUR inférieure à 10.000.000 avec les
   points de séparation des puissances de 1000 et des espaces en tête pour avoir
   toujours 9 caractères affichés. Ce programme fonctionne sur la ligne série USB
   et permet de vérifier l'organigramme en vue de la versions pour LCD.
   
  SHIELD LCD       Mini module indépendant. (Vendu en KIT.)
  D8               D2  - RS  (LCD)
  Masse            D3  - R/W (LCD)
  D9               D4  - E   (LCD)
  D4               D6  - DB4 (LCD)
  D5               D7  - DB5 (LCD)
  D6               D8  - DB6 (LCD)
  D7               D9  - DB7 (LCD)
  D13              D10 - Pilotage de la base du transistor de rétroéclairage.
  D10              D5  - Entrée de comptage.  */

#include <LiquidCrystal.h>

// Déclaration de l'afficheur LCD pour le SHIELD ARDUINO.
//LiquidCrystal MonEcran(8, 3, 9, 4, 5, 6, 7);
//#define RETRO  13

//Déclaration de l'afficheur LCD pour le mini module vendu en KIT.
  LiquidCrystal MonEcran(2, 3, 4, 6, 7, 8, 9);
  #define RETRO  10  

// Variables du programme.   
unsigned long VALEUR = 2000000; // Valeur numérique de la donnée à afficher.
boolean ESPACE; // Signale qu'il faut compléter avec des espaces et non des "0".
unsigned int PAQUET; // Valeur numérique comprise entre 0 et 999.

void setup() {pinMode(RETRO, OUTPUT);  // Contrôle du rétroéclairage. 
  digitalWrite(RETRO, HIGH);  // Allumer le rétroéclairage.
  // Déclaration des caractéristiques de l'afficheur LCD. 
  MonEcran.begin(16, 2); // Deux lignes de 16 caractères.
  MonEcran.home(); MonEcran.print("Test avec FORMAT");}
  
void loop() {if (VALEUR > 0) {VALEUR = VALEUR - 10000;}
  Affiche_VALEUR_avec_formatage();
  delay(100);} // Décrémenter de 10000 pour test "rapide".
 
//@@@@@@@@@@@@@@@ Ci-dessous code à ajouter au programme utilisateur @@@@@@@@@@@@@@@

/* Variables à introduire dans le programme en cours de développement :   
unsigned long VALEUR = 0; // Valeur numérique de la donnée à afficher.
boolean ESPACE; // Signale qu'il faut compléter avec des espaces et non des "0".
unsigned int PAQUET; // Valeur numérique comprise entre 0 et 999. */
  
void COMPLETER() {if (ESPACE) {MonEcran.print(" ");} else {MonEcran.print("0");} } 
  
void Afficher_un_PAQUET() { // Valeur comprise entre 0 et 999.
  if (PAQUET < 100) {COMPLETER();} // Afficher un espace ou un zéro.
  if (PAQUET < 10) {COMPLETER();}  // Afficher un autre espace ou un autre zéro.
  if (PAQUET == 0) {COMPLETER();} else {MonEcran.print(PAQUET);} }

void Affiche_VALEUR_avec_formatage() {
  // Formate l'affichage pour placer les points et les espaces en tête pour
  // 9 caractères. Ne modifie pas la variable VALEUR.
  unsigned long SAV_VALEUR = VALEUR;  boolean Mega_non_nul;
  ESPACE = true; // Commencer par des espaces si valeur insuffisante.
  MonEcran.setCursor(4, 1); // Curseur placé en colonne 4 sur la ligne 2.
  /*>>>>>>>>>>>>>>>>>>>>>>>>>>>> Afficher les MEGA <<<<<<<<<<<<<<<<<<<<<<<<<<<*/
  PAQUET = VALEUR / 1000000; // Isoler les Méga dans PAQUET et VALEUR inchangée.
  // Si > 0 afficher les Méga suivi d'un point, si non afficher deux espaces.
  if (PAQUET == 0) {MonEcran.print("  "); ; Mega_non_nul = false;}
      else {MonEcran.print(PAQUET); MonEcran.print("."); ESPACE = false; Mega_non_nul = true;
            // Enlever les MEGA déjà affichés dans VALEUR :
            VALEUR = VALEUR - (PAQUET * 1000000); }
  /*>>>>>>>>>>>>>>>>>>>>>>>>>>>> Afficher les KILO <<<<<<<<<<<<<<<<<<<<<<<<<<<*/
  PAQUET = VALEUR / 1000; // Isoler les KILO dans PAQUET et VALEUR inchangée.
  Afficher_un_PAQUET();
  if ((PAQUET > 0) | (Mega_non_nul))
     {MonEcran.print("."); ESPACE = false;} else {MonEcran.print(" "); } 
  /*>>>>>>>>>>>>>>>>>>>>>>>>>>> Afficher les UNITÉS <<<<<<<<<<<<<<<<<<<<<<<<<<*/
  // Enlever les KILO déjà affichés à VALEUR.
  if (PAQUET > 0) {PAQUET = VALEUR - (PAQUET * 1000);} else {PAQUET = VALEUR;}
  if ((PAQUET == 0) && (ESPACE)) {MonEcran.print("  0");} else {Afficher_un_PAQUET();}
  VALEUR = SAV_VALEUR;}
  
  
  
