/* Petit programme qui gère un B.P. avec antirebonds.
   Chaque action sur A0 fait recycler une option du menu.
   Pour témoin lumineux inverse aussi l'état de la LED 13.
   L'option active du MENU s'affiche sur la ligne série USB.
   La boucle de base se contente d'un travail de fond relatif
   à l'option en cours indexée par le byte"Option_du_MENU".
   C'est le traitement du B.P. qui affiche la nature de
   l'option qui vient d'être indexée. */
   
// Constantes utilisées.
#define LED_ARDUINO 13
#define NB_tests_antirebonds 50 // Nombre de tests de stabilisation.
#define NB_Options 5 // Options indexées entre 1 et N. Ici 5 options.

// Variables utilisées.
boolean Clic_sur_le_BP;
byte Option_du_MENU = 1; // Ordre de l'option en cours.

void setup(){ Serial.begin(115200);
  pinMode(LED_ARDUINO, OUTPUT); digitalWrite(LED_ARDUINO, HIGH);
  Serial.begin(115200); Serial.println();
  Affiche_nature_Option_Indexee(); Serial.println(); }

void loop(){
  Tester_le_BP_A0(); 
  if (Clic_sur_le_BP) {
    // Inverse l'état de la LED d'Arduino.
    digitalWrite(LED_ARDUINO,!digitalRead(LED_ARDUINO));
    // Prise en compte de l'action sur le B.P.
    Clic_sur_le_BP = false;
    // Traitement de l'option.
    Option_du_MENU++; if (Option_du_MENU > NB_Options) {Option_du_MENU = 1;}
    Affiche_nature_Option_Indexee(); }
  delay(100); // Ralentir la boucle pour ne pas "saturer" l'affichage série USB.
  // Traitement de routine de l'option active.
  switch(Option_du_MENU) {
    case 1 : {Serial.println(Option_du_MENU); break;} // Traite l'option 1.
    case 2 : {Serial.println(Option_du_MENU); break;} // Traite l'option 2.
    case 3 : {Serial.println(Option_du_MENU); break;} // Traite l'option 3.
    case 4 : {Serial.println(Option_du_MENU); break;} // Traite l'option 4.
    case 5 : {Serial.println(Option_du_MENU); break;} } } // Option N.
  
void Affiche_nature_Option_Indexee() {
    switch(Option_du_MENU) {
    case 1 : {Serial.println("Option 1 en cours."); break;}
    case 2 : {Serial.println("Option 2 en cours."); break;}
    case 3 : {Serial.println("Option 3 en cours."); break;}
    case 4 : {Serial.println("Option 4 en cours."); break;}
    case 5 : {Serial.println("Option 5 en cours."); break;} } } // Option N.
     
// >>>>>>>>>>>>> Le B.P. est câblé en logique positive <<<<<<<<<<<<<<<<<<
/*
void Tester_le_BP_A0() { // La lecture sur A0 donne 0 ou 1023.
  byte COMPTEUR;
  if (analogRead(0) > 512){Clic_sur_le_BP = true;
    // Attendre_la_stabilisation à "1".
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; if (analogRead(0) < 512) {COMPTEUR = 0;} }
    // Attendre_la_stabilisation à "0".
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; if (analogRead(0) > 512) {COMPTEUR = 0;} } } }
*/

// >>>>>>>>>>>>> Le B.P. est câblé en logique négative <<<<<<<<<<<<<<<<<<
void Tester_le_BP_A0() { // La lecture sur A0 donne 0 ou 1023.
  byte COMPTEUR;
  if (analogRead(0) < 512){Clic_sur_le_BP = true; 
    // Attendre_la_stabilisation à "0".
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; if (analogRead(0) > 512) {COMPTEUR = 0;} }
    // Attendre_la_stabilisation à "1".
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; if (analogRead(0) < 512) {COMPTEUR = 0;} } } }


