/*  Ohmmètre sur ligne série USB.
 Pour des raisons d'anticipation d'un autre programme, les entrées analogiques
 A0 et A1 ne sont pas utilisées.
 A2 est reliée au +5Vcc par 1000 ohms. Calibre 100 ohms à 100k ohms.
 A3 est reliée au +5Vcc par 100 ohms. Calibre inférieur à 100 ohms. */

#define Mesure1K 2 // Entrée analogique 2 utilisée.
#define Mesure100ohms 3 // Entrée analogique 3 utilisée.
#define N 400 // Nombre de mesures pour faire une moyenne.

float Tension_lue;
float Resistance, Ancienne_valeur;
boolean Entree_A2;

float N_Tensions_lues; // Valeur cumulée.

void setup() {
  Serial.begin(115200);
  Serial.print("  >>>> Mesure de "); Affiche_le_mot_resistance();
  Serial.print("s <<<<");
  Serial.println(); Serial.println(); }

void loop() {
  // Mesures sur A2 avec résistance de limitation de 1000 ohms.
  N_mesures_sur_A2();
  Resistance = Tension_lue * 1000 / (5000 - Tension_lue);
  if (Resistance < 200) {
    Serial.println(); Serial.println();
    Serial.println("  Changer de calibre."); Serial.println();
    delay(1000);}
   if (Tension_lue < 4960)
     { Entree_A2 = true; Affiche_la_valeur_de_la_resistance();} // N'affiche que si changée.
  // Mesures sur A3 avec résistance de limitation de 100 ohms.
  N_mesures_sur_A3();
  Resistance = Tension_lue * 100 / (5000 - Tension_lue);
  if (Tension_lue < 4960)
     { Entree_A2 = false; Affiche_la_valeur_de_la_resistance();} } // N'affiche que si changée.
  
 void N_mesures_sur_A3() { 
   N_Tensions_lues = 0;
   for (int I = 0; I < (N) ; I++) 
       {Tension_lue = analogRead(Mesure100ohms); // Mesure analogique [0 à 1023].
       N_Tensions_lues = N_Tensions_lues + Tension_lue; }
       Realise_la_moyenne(); }
  
 void N_mesures_sur_A2() { 
   N_Tensions_lues = 0;
   for (int I = 0; I < (N) ; I++) 
       {Tension_lue = analogRead(Mesure1K); // Mesure analogique [0 à 1023].
       N_Tensions_lues = N_Tensions_lues + Tension_lue; }
       Realise_la_moyenne(); }
       
 void Realise_la_moyenne() {        
  Tension_lue = N_Tensions_lues / N;
  Tension_lue = map(Tension_lue, 0, 1023, 0, 5000); // Tension en volts * 1000.
  if (Tension_lue == 5000) {Tension_lue = 4999.99;} }
  // 4999.99 au lieu de 5000 pour viter une division par zéro dans le calcul de R. 
  
 void Affiche_le_mot_resistance() {
   Serial.print("R"); Serial.print(char (233)); Serial.print("sistance");}
 
 void Affiche_la_valeur_de_la_resistance() {  
  if (Resistance != Ancienne_valeur) {
  Ancienne_valeur = Resistance;
  Serial.print("  Tension lue = ");
  Serial.print(Tension_lue/1000,3);
  Serial.print("   "); Affiche_le_mot_resistance(); Serial.print(" sur ");
  if (Entree_A2) {Serial.print("A2");} else {Serial.print("A3");}
  Serial.print(" = ");   Serial.println(Resistance,1); } }
   
