/*  Ampèremètre sur ligne série USB.
 Pour des raisons d'anticipation d'un autre programme, les entrées analogiques
 A0 à A3 ne sont pas utilisées ici.
 A4 est reliée à une résistance de 10 ohms qui va à la masse.
 A5 est reliée à une résistance de 100 ohms qui va à la masse. */

#define Intensité_sur_A4 4 // Entrée analogique 4 utilisée.
#define Intensité_sur_A5 5 // Entrée analogique 5 utilisée.

#define N 400 // Nombre de mesures pour faire une moyenne.
#define K10 1.04 // Corrige la valeur du shunt de 1 ohm.
#define K100 1.05 // Corrige la valeur du shunt de 10 ohm.

float Tension_lue;
float Intensite, Ancienne_Intensite;
float N_Tensions_lues; // Valeur cumulée.

boolean Entree_A4;

void setup() {
  Serial.begin(115200);
  Serial.print("  >>>> Mesure d'"); Affiche_le_mot_Intensite();
  Serial.print("s <<<<");
  Serial.println(); Serial.println(); }

void loop() {
  // Mesures sur A4 avec résistance shunt de 10 ohms.
  N_mesures_pour_Intensite(4); Entree_A4 = true;
  Intensite = Tension_lue * K10 / 10;
  if ((Intensite < 50) && (Intensite > 0)) {
    Serial.println(); Serial.println();
    Serial.println("  Changer de calibre."); Serial.println();
    delay(1000);}
  // Si zéro sur A4 mesurer sur A5 avec résistance shunt de 100 ohms.
  if (Intensite == 0) {
      N_mesures_pour_Intensite(5); Entree_A4 = false;
      Intensite = Tension_lue * K100 / 100;}
  Affiche_Intensite(); }

void N_mesures_pour_Intensite(byte ENTREE) { 
  N_Tensions_lues = 0;
  for (int I = 0; I < (N) ; I++) 
       {Tension_lue = analogRead(ENTREE); // Mesure analogique [0 à 1023].
       N_Tensions_lues = N_Tensions_lues + Tension_lue; }
  Tension_lue = N_Tensions_lues / N;
  Tension_lue = map(Tension_lue, 0, 1023, 0, 5000); // Tension en volts * 1000.
  if (Tension_lue == 5000) {Tension_lue = 4999.99;} }
  // 4999.99 au lieu de 5000 pour viter une division par zéro dans le calcul de R. 
  
 void Affiche_le_mot_Intensite() {Serial.print("Intensit"); Serial.print(char (233));}
 
 void Affiche_Intensite() {  
  if (Intensite != Ancienne_Intensite) {
  Ancienne_Intensite = Intensite;
  Serial.print("Tension lue sur ");
  if (Entree_A4) {Serial.print("A4");} else {Serial.print("A5");}
  Serial.print(" = "); Serial.print(Tension_lue/1000);
  Serial.print(" "); Affiche_le_mot_Intensite(); Serial.print(" = ");
  if (Entree_A4) {Serial.print(Intensite,0);} else {Serial.print(Intensite,1);}
  Serial.println(" mA"); } } 

  
   
