/* Ce petit programme permet de développer un menu avec deux B.P. pour sélectionner
   les options, mais dans leur liste des "Fonctions Bouclées" qui demandent
   confirmation. Le B.P. "Prograde" sert à confirmer, le B.P. rétrograde engendre
   le passage à la fonction voisine. le sens de cheminement dans le menu est conservé.
   Les deux B.P. sont branchés sur A0 et permettent de gérer un nombre quelconque
   de fonctions. Le schéma de branchement des B.P. est donné ci-dessous :
   GND---10k---A0---10k-------1k---+5Vcc
   |--<BP+>----|---<BP+>--|
   C'est la boucle de base qui informée par le booléen [Clic_sur_le_BP] gère la
   requête en analysant la valeur du booléen [Augmenter_le_choix].
   Si l'on enfonce un B.P. plus d'une seconde le menu est réinitialisé à 1.
   La procédure Tester_le_BP_A0 assure l'anti rebonds.   */

// Constantes utilisées.
#define NB_tests_antirebonds 50 // Nombre de tests de stabilisation B.P.
#define NB_Options 6 // Options indexées entre 1 et 6.
#define LED_Arduino 13

// Variables utilisées.
boolean Clic_sur_le_BP, Augmenter_le_choix, Retour_a_1;
byte Option_du_MENU = 1; // Ordre de l'option en cours.
boolean Confirmation; // Un choix est confirmé si égal à true. 

void setup() {
  Serial.begin(115200);
  Serial.println(">>> TESTER un MENU avec Fonctions Bouclees. <<<"); Serial.println();
  Serial.println("Fonction INITIALE num 1 en cours.");
  pinMode(LED_Arduino, OUTPUT); digitalWrite(LED_Arduino, LOW); }

void loop() {
  Tester_entree_A0(); // Pour détection dans la boucle de base.
  // ===== Traiter la requête de l'un des deux B.P. =====
  if (Clic_sur_le_BP) {
    Clic_sur_le_BP = false; // Action sur le B.P. prise en compte.
    if (Augmenter_le_choix)
         {Option_du_MENU++; if (Option_du_MENU > NB_Options) {Option_du_MENU = 1; } }
    else {Option_du_MENU--; if (Option_du_MENU == 0) {Option_du_MENU = NB_Options; } }
    if (Retour_a_1) { Option_du_MENU = 1; }
    Affiche_nature_Option_Indexee(); }
  // ===== Traitement de routine de l'option active ici. =====
  switch (Option_du_MENU) {
    case 1 : { ; break; }
    case 2 : { ; break; }
    case 3 : {CONFIRMER();  if (Confirmation) Fonction_bouclee_3(); break; }
    case 4 : { ; break; }
    case 5 : {CONFIRMER(); if (Confirmation) Fonction_bouclee_5();break; }
    case 6 : { ; break; } } }

void Affiche_nature_Option_Indexee() {
  Serial.println();
  switch (Option_du_MENU) {
    case 1 : { Serial.println("Fonction INITIALE num 1."); Serial.println(); break; }
    case 2 : { Serial.println("Fonction num 2."); Serial.println(); break; }
    case 3 : { Serial.print("Fonction Bouclee 3"); break; }
    case 4 : { Serial.print("Fonction num 4."); break; }
    case 5 : { Serial.print("Fonction Bouclee 5"); break; }
    case 6 : { Serial.println("Fonction num 6."); Serial.println(); break; } } }

// >>>>>>>>>>>>> Le B.P. est câblé en "Analogique" <<<<<<<<<<<<<<<<<<
void Tester_entree_A0() { // La lecture sur A0 donne 0 ou 930 maximum.
  int Numerisation_BP; // Valeur retournée par la CAN de A0.
  byte COMPTEUR; unsigned long Horloge_actuelle;
  Numerisation_BP = analogRead(0);
  if ((Numerisation_BP > 710) || (Numerisation_BP < 240)) {
    Clic_sur_le_BP = true; digitalWrite(LED_Arduino, HIGH);
    Augmenter_le_choix = false;
    Horloge_actuelle = millis(); Retour_a_1 = false;
    if (Numerisation_BP > 710) { Augmenter_le_choix = true; }
    delay(100); // Attendre_la_stabilisation du travail.
    // Attendre_la_stabilisation du repos :
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; Numerisation_BP = analogRead(0);
      if ((Numerisation_BP > 710) || (Numerisation_BP < 240)) { COMPTEUR = 0; } }
    digitalWrite(LED_Arduino, LOW); // Éteindre la LED verte.
    if ((millis() - Horloge_actuelle) > 1000) Retour_a_1 = true; } }

void Fonction_bouclee_3() {
  Clic_sur_le_BP = false; Serial.print("FONCTION 3 en cours > Un BP pour ressortir.");
  while (!Clic_sur_le_BP) Tester_entree_A0(); }

void Fonction_bouclee_5() {
  Clic_sur_le_BP = false; Serial.print("FONCTION 5 en cours > Un BP pour ressortir.");
  while (!Clic_sur_le_BP) Tester_entree_A0(); }

void CONFIRMER() { // Si non confirmé fait croire à une demande d'option voisine.
  boolean Mode_actuel = Augmenter_le_choix; // Mémorise le sens actuel de cheminement.
  Serial.print(" ? --> Confirmez : ");
  while (!Clic_sur_le_BP) Tester_entree_A0(); // Attente d'une action sur l'un des deux B.P.
  Confirmation = Augmenter_le_choix; // Confirmé si B.P. d'option prograde activé.
  Augmenter_le_choix = Mode_actuel;  Serial.println(); }


