/* Programme de comptage avec prise en compte des débordements.
   Dans cette version le compteur est forcé à zéro à 9.999.999.
   Cette valeur anticipe un futur affichage sur LCD formaté avec points décimaux. */

#define Entree_Compteur 5 // Entrée D5 pour servira aussi pour mesurer les fréquences.

// Variables du programme.
volatile byte Nb_IRQ; // Le COMPTEUR sera bloqué à 152 Interruptions.
unsigned long COMPTEUR, Ancienne_Valeur;

ISR(TIMER1_OVF_vect) {Nb_IRQ++;} //Routine d'interruption sur débordement du TIMER1.

void setup() {
  Serial.begin(115200); pinMode(Entree_Compteur, INPUT);}

void loop() {Serial.println(); Serial.println("FONCTION COMPTEUR.");
  TCCR1A = 0;   // Le Timer 1 est configuré en simple compteur.
  RAZ_COMPTEUR(); // Initialise aussi pour source sur D5 et comptage sur le front montant.
  // ============== Autoriser les interruptions sur débordement =================
  TIMSK1 |= (1<<TOIE1);
  Boucle_INFINIE:
  //========================= Traiter le COMPTEUR ===============================
  // Ci-dessous une première lecture fait passer TCNT1H dans le TAMPON.
  COMPTEUR = TCNT1;
  // Lecture des 16 bits dans la variable COMPTEUR et ajoute le DEBORDEMENT.
  COMPTEUR = TCNT1 + (65536 * Nb_IRQ);
  if (COMPTEUR > 9999999)
     {COMPTEUR = 9999999; TCCR1B = 0;} // Bloquer le compteur.
  // ============================================================================
  if(COMPTEUR != Ancienne_Valeur) {
  Serial.print(" CMPT = ");
  if (COMPTEUR < 1000000) Serial.print(" ");
  if (COMPTEUR < 100000) Serial.print(" "); 
  if (COMPTEUR < 10000) Serial.print(" ");
  if (COMPTEUR < 1000) Serial.print(" ");
  if (COMPTEUR < 100) Serial.print(" ");
  if (COMPTEUR < 10) Serial.print(" ");  
  Serial.println(COMPTEUR); Ancienne_Valeur = COMPTEUR;}
  goto Boucle_INFINIE; }
  
void RAZ_COMPTEUR() {
  COMPTEUR = 0; Ancienne_Valeur = 1; // Pour forcer l'affichage; 
  // Replacer le compteur à zéro pour une nouvelle mesure.
  TCNT1 = 0x0000; // Remettre le TIMER1 à zéro, autre écriture possible : TCNT1 = 0;
  Nb_IRQ=0; 
  // 111 pour Source externe sur D5 et comptage sur le front montant :
  TCCR1B = (1<<CS12) | (1<<CS11) | (1<<CS10);}
