/* Programme pour mettre au point la génération du signal carré sur D12.
   L'instruction tone empêche la génération simultannée de la PWM.    */
   
// Définition des E/S pour ce programme.
#define LED_Arduino 13
#define Sortie_SIGNAL 12   // Signal BF carré généré sur D12..
#define MESURE 1 // A1 utilisée car A0 réservée aux deux B.P.
#define N 1000 // Nombre de mesures pour faire une moyenne.
#define NB_tests_antirebonds 50 // Nombre de tests de stabilisation B.P.

// Variables du programme.
float Tension_lue,N_Tensions_cumulees, Ancienne_Valeur ;
long QRG = 500; // Fréquence générée sur D12.
boolean Clic_sur_le_BP, Augmenter_le_choix, Clic_long;
byte Plage_QRG = 2;
boolean ESPACE; // Signale qu'il faut compléter avec des espaces et non des "0".
unsigned int PAQUET; // Valeur numérique comprise entre 0 et 999.
unsigned long VALEUR;

void setup() {
  Serial.begin(115200); pinMode(LED_Arduino, OUTPUT); digitalWrite(LED_Arduino, LOW); }

void loop() {
Tension_lue = analogRead(1); // Mesure analogique [0 à 1023].
  N_Tensions_cumulees = 0;
  for (int I = 0; I < (N) ; I++) 
      {Tension_lue = analogRead(1); // Mesure analogique [0 à 1023].
       N_Tensions_cumulees = N_Tensions_cumulees + Tension_lue; }
  Tension_lue = N_Tensions_cumulees / N;
  Tester_entree_A0();
  if (Clic_sur_le_BP) { Clic_sur_le_BP = false;
     if ((Augmenter_le_choix) && (!Clic_long)) {if (Plage_QRG < 4) Plage_QRG++; else Plage_QRG = 1;}
     if (!Augmenter_le_choix) {if (Plage_QRG > 1) Plage_QRG--; else Plage_QRG = 4;} }
  // =============== M.A.J. la plage de variation ===============
  //Calculer la valeur de la tension lue sur l'entrée du multimètre.
  switch (Plage_QRG) {
    case 1 : {QRG = map(Tension_lue, 15, 1000, 31, 200); break;} // Fréquence en Hz.
    case 2 : {QRG = map(Tension_lue, 11, 1005, 150, 2000); break;} // Fréquence en Hz.
    case 3 : {QRG = map(Tension_lue, 10, 1005, 1500, 10000); break;} // Fréquence en Hz.
    case 4 : {QRG = map(Tension_lue, 9, 1010, 9000, 50000); break;} } // Fréquence en Hz.
  if (QRG != Ancienne_Valeur) {      
      Ancienne_Valeur = QRG; tone(Sortie_SIGNAL,QRG);
      switch (Plage_QRG) {
        case 1 : {Serial.print("[31 a 200] "); break;}
        case 2 : {Serial.print("[150 a 2000] "); break;}
        case 3 : {Serial.print("[1500 a 10000] "); break;}
        case 4 : {Serial.print("[9000 a 50000] "); break;} }
      Serial.print("Fr"); Serial.print(char (233)); Serial.print("quence fournie = ");
      VALEUR = QRG; Affiche_VALEUR_avec_formatage(); Serial.println(); } }
  
void COMPLETER() {if (ESPACE) {Serial.print(" ");} else {Serial.print("0");} } 
  
void Afficher_un_PAQUET() {// Valeur comprise entre 0 et 999.
  if (PAQUET < 100) {COMPLETER();} // Afficher un espace ou un zéro.
  if (PAQUET < 10) {COMPLETER();}  // Afficher un autre espace ou un autre zéro.
  if (PAQUET == 0) {COMPLETER();} else {Serial.print(PAQUET);} }

void Affiche_VALEUR_avec_formatage() {
  // Formate l'affichage pour placer les points et les espaces en tête pour
  // 9 caractères. Ne modifie pas la variable VALEUR.
  unsigned long SAV_VALEUR = VALEUR; boolean Mega_non_nul;
  ESPACE = true; // Commencer par des espaces si valeur insuffisante.
  /*>>>>>>>>>>>>>>>>>>>>>>>>>>>> Afficher les MEGA <<<<<<<<<<<<<<<<<<<<<<<<<<<*/
  PAQUET = VALEUR / 1000000; // Isoler les Méga dans PAQUET et VALEUR inchangée.
  // Si > 0 afficher les Méga suivi d'un point, si non afficher deux espaces.
  if (PAQUET == 0) {Serial.print("  "); Mega_non_nul = false;}
      else {Serial.print(PAQUET); Serial.print("."); ESPACE = false; Mega_non_nul = true;
            // Enlever les MEGA déjà affichés dans VALEUR :
            VALEUR = VALEUR - (PAQUET * 1000000); }
  /*>>>>>>>>>>>>>>>>>>>>>>>>>>>> Afficher les KILO <<<<<<<<<<<<<<<<<<<<<<<<<<<*/
  PAQUET = VALEUR / 1000; // Isoler les KILO dans PAQUET et VALEUR inchangée.
  Afficher_un_PAQUET();
  if ((PAQUET > 0) | (Mega_non_nul))
     {Serial.print("."); ESPACE = false;} else {Serial.print(" "); } 
  /*>>>>>>>>>>>>>>>>>>>>>>>>>>> Afficher les UNITÉS <<<<<<<<<<<<<<<<<<<<<<<<<<*/
  // Enlever les KILO déjà affichés à VALEUR.
  if (PAQUET > 0) {PAQUET = VALEUR - (PAQUET * 1000);} else {PAQUET = VALEUR;}
  if ((PAQUET == 0) && (ESPACE)) {Serial.print("  0");} else {Afficher_un_PAQUET();}
  VALEUR = SAV_VALEUR; }
    
 // >>>>>>>>>>>>> Le B.P. est câblé en "Analogique" <<<<<<<<<<<<<<<<<<
void Tester_entree_A0() { // La lecture sur A0 donne 0 ou 930 maximum.
  int Numerisation_BP; // Valeur retournée par la CAN de A0.
  byte COMPTEUR; unsigned long Horloge_actuelle;
  Numerisation_BP = analogRead(0);
  if ((Numerisation_BP > 710) || (Numerisation_BP < 240)) {
    Clic_sur_le_BP = true; digitalWrite(LED_Arduino, HIGH);
    Augmenter_le_choix = false;
    Horloge_actuelle = millis(); Clic_long = false;
    if (Numerisation_BP > 710) { Augmenter_le_choix = true; }
    delay(100); // Attendre_la_stabilisation du travail.
    // Attendre_la_stabilisation du repos :
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; Numerisation_BP = analogRead(0);
      if ((Numerisation_BP > 710) || (Numerisation_BP < 240)) { COMPTEUR = 0; } }
    digitalWrite(LED_Arduino, LOW); // Éteindre la LED verte.
    if ((millis() - Horloge_actuelle) > 1000) Clic_long = true; } }

