/* Programme démonstrateur pour piloter par une tension extérieure
   un générateur B.F. utilisant un Arduino UNO.
   Le signal sur LED Arduino donne une période de boucle
   d'environ 61650µS.   */
   
// Définition des E/S pour ce programme.
#define LED_Arduino 13
#define Sortie_SIGNAL 12   // Signal BF carré généré sur D12..
#define N 500 // Nombre de mesures pour faire une moyenne.

#define Borne_INF 50 // Valeur pour affichage de 0.5 en analogique.
#define Borne_SUP 880 // Valeur pour affichage de 5 en analogique.

// Variables du programme.
float Tension_lue,N_Tensions_cumulees, Ancienne_Valeur ;
long QRG; // Fréquence générée sur D12.

void setup() {
  pinMode(LED_Arduino, OUTPUT); pinMode(Sortie_SIGNAL, OUTPUT); }

void loop() {
  digitalWrite(LED_Arduino, HIGH);
  Tension_lue = analogRead(0); // Mesure analogique [0 à 1023].
  N_Tensions_cumulees = 0;
  for (int I = 0; I < (N) ; I++) 
      {Tension_lue = analogRead(1); // Mesure analogique [0 à 1023].
       N_Tensions_cumulees = N_Tensions_cumulees + Tension_lue; }
  Tension_lue = N_Tensions_cumulees / N;
  if (Tension_lue < Borne_INF) Tension_lue = Borne_INF;
  QRG = map(Tension_lue, Borne_INF, Borne_SUP, 50, 500); // Fréquence en Hz.
  if (QRG != Ancienne_Valeur) {Ancienne_Valeur = QRG; tone(Sortie_SIGNAL,QRG); }
  digitalWrite(LED_Arduino, LOW); }
    

