/* Programme pour mettre au point la génération d'un signal carré sur D12.
   Comme il s'agit d'un étalon de fréquence, la période doit être rigoureuse.
   Dans ce PGM la durée "LONGUE" est réduite à 0.5 seconde pour tester.
   L'instruction tone() utilise le TIMER2 donc la génération sur PWM11
   n'est pas possible.   */
   
// Définition des E/S pour ce programme.
#define LED_Arduino 13
#define Sortie_SIGNAL 12   // Generation du signal étalon sur D12.
#define NB_tests_antirebonds 50 // Nombre de tests de stabilisation B.P.
#define MAX_QRG_ETALON 14 // Nombre de fréquences possigbles entre 1 et cette valeur.

// Variables du programme.
boolean Clic_sur_le_BP, Augmenter_le_choix, Clic_long;
byte QRG_ETALON; // Numéro de la fréquence à générer.

void setup() {
  Serial.begin(115200);
  Serial.println(">>> GENERATEUR ETALON <<<"); Serial.println();
  pinMode(LED_Arduino, OUTPUT); digitalWrite(LED_Arduino, LOW);
  pinMode(Sortie_SIGNAL, OUTPUT);}
  
void loop() {
  Fonction_ETALON_de_QRG();
  Serial.println(); Serial.println("On vient d'en sortir."); Serial.println();
  delay(5000); // Pour vérifier le noTone().
  Serial.println("On y retourne !"); Serial.println(); Clic_sur_le_BP = false;}

void Fonction_ETALON_de_QRG() {
  QRG_ETALON = 7; Afficher_QRG_produite();
  Clic_long = false; Augmenter_le_choix = true; 
  while (!(Augmenter_le_choix && Clic_long)) {
  //========================== tant que non SORTIE ==========================
  Tester_entree_A0();
  if (Clic_sur_le_BP) {
     if (!Clic_long) 
        { Clic_sur_le_BP = false;
          if (Augmenter_le_choix) {if (QRG_ETALON < MAX_QRG_ETALON) QRG_ETALON++;}
                             else {if (QRG_ETALON > 1) QRG_ETALON--;}
        Afficher_QRG_produite();} } }
  //========================================================================
  noTone(Sortie_SIGNAL);}
        
void Afficher_QRG_produite() {
  Serial.print("Fr"); Serial.print(char (233));Serial.print("quence fournie = ");
  switch (QRG_ETALON) {
    case 1 : {Serial.print("50 "); QRG_ETALON = 1; tone(Sortie_SIGNAL,50); break;}
    case 2 : {Serial.print("75 "); QRG_ETALON = 2; tone(Sortie_SIGNAL,75); break;}
    case 3 : {Serial.print("100 "); QRG_ETALON = 3; tone(Sortie_SIGNAL,100); break;}
    case 4 : {Serial.print("200 "); QRG_ETALON = 4; tone(Sortie_SIGNAL,200); break;}
    case 5 : {Serial.print("250 "); QRG_ETALON = 5; tone(Sortie_SIGNAL,250); break;}
    case 6 : {Serial.print("500 "); QRG_ETALON = 6; tone(Sortie_SIGNAL,500); break;}
    case 7 : {Serial.print("1000 "); QRG_ETALON = 7; tone(Sortie_SIGNAL,1000); break;}
    case 8 : {Serial.print("2000 "); QRG_ETALON = 8; tone(Sortie_SIGNAL,2000); break;}
    case 9 : {Serial.print("2500 "); QRG_ETALON = 9; tone(Sortie_SIGNAL,2500); break;}
    case 10 : {Serial.print("5000 "); QRG_ETALON = 10; tone(Sortie_SIGNAL,5000); break;}
    case 11 : {Serial.print("10000 "); QRG_ETALON = 11; tone(Sortie_SIGNAL,10000); break;}
    case 12 : {Serial.print("20000 "); QRG_ETALON = 12; tone(Sortie_SIGNAL,20000); break;}
    case 13 : {Serial.print("50000 "); QRG_ETALON = 13; tone(Sortie_SIGNAL,50000); break;}
    case 14 : {Serial.print("LA (3) 440 "); QRG_ETALON = 14; tone(Sortie_SIGNAL,440); break;} }
  Serial.println(" Hz");}
    
 // >>>>>>>>>>>>> Le B.P. est câblé en "Analogique" <<<<<<<<<<<<<<<<<<
void Tester_entree_A0() { // La lecture sur A0 donne 0 ou 930 maximum.
  int Numerisation_BP; // Valeur retournée par la CAN de A0.
  byte COMPTEUR; unsigned long Horloge_actuelle;
  Numerisation_BP = analogRead(0);
  if ((Numerisation_BP > 710) || (Numerisation_BP < 240)) {
    Clic_sur_le_BP = true; digitalWrite(LED_Arduino, HIGH);
    Augmenter_le_choix = false;
    Horloge_actuelle = millis(); Clic_long = false;
    if (Numerisation_BP > 710) { Augmenter_le_choix = true; }
    delay(100); // Attendre_la_stabilisation du travail.
    // Attendre_la_stabilisation du repos :
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; Numerisation_BP = analogRead(0);
      if ((Numerisation_BP > 710) || (Numerisation_BP < 240)) { COMPTEUR = 0; } }
    digitalWrite(LED_Arduino, LOW); // Éteindre la LED verte.
    if ((millis() - Horloge_actuelle) > 1000) Clic_long = true; } }

