/*  Expérimentation du TESTEUR DE CONTINUITE.
    La tonalité est générée sur D12.
    Pas de génération PWM sur D11.         */

#define Sortie_SIGNAL 12 // Generation du signal étalon sur D12.
#define LED_Arduino 13 // LED verte sur le C.I.
#define NB_tests_antirebonds 50 // Nombre de tests de stabilisation B.P.


// Variables du programme.
int N = 400; // Nombre de mesures pour faire une moyenne.
boolean Clic_sur_le_BP, Augmenter_le_choix, Clic_long;
float Tension_lue, N_Tensions_cumulees;

void setup() {
  Serial.begin(115200);
  pinMode(LED_Arduino, OUTPUT); digitalWrite(LED_Arduino, LOW);
  pinMode(Sortie_SIGNAL, OUTPUT); Serial.println();
  Serial.println(">>> TESTEUR de CONTINUITE. <<<");
  Fonction_TESTEUR_de_CONTINUITE();}

void loop() {}
   
void Fonction_TESTEUR_de_CONTINUITE() {
  // L'instruction tone() utilise le TIMER2 donc pas de génération sur PWM11.
  N = 100; // Diminuer le nombre de mesure pour augmenter la rapidité.
  boolean Debit_50mA = false; // Test à "forte intensité". (50mA sur CC.)
  //-------------- Initialiser pour afficher A2 utilisée --------------
  Clic_long = false; Augmenter_le_choix = false; Clic_sur_le_BP = true;
  while (!(Augmenter_le_choix && Clic_long)) {
  //========================== Tant que non SORTIE ==========================
  Tester_le_BP_A0();
  //-------------- Traiter les deux B.P. --------------
  if (Clic_sur_le_BP) {
     Clic_sur_le_BP = false; Serial.println(); Serial.print(" Mesure sur ");
     if (Augmenter_le_choix) {Debit_50mA = true; Serial.print("A3 (50mA)");}
        else {Debit_50mA = false; Serial.print("A2 (5mA)");} }
  //---------------------------------------------------
  Serial.print("Tension lue = "); Serial.println(Tension_lue);
  // Mesurer la continuité sur A2 ou A3.
  if (Debit_50mA) N_mesures_sur_Ai(3); // Débit Max 50mA.
     else N_mesures_sur_Ai(2); // Débit Max 5mA.
  // Générer la tonalité.
  // 454 : résistance > 100 ohm. (Silence)
  // 327 à 454 : résistance entre 70 et 100 ohm. (150 Hz)
  // 192 à 327 : résistance entre 40 et 70 ohm. (300 Hz)
  // 98 à 192 : résistance entre 20 et 40 ohm. (800 Hz)
  // 75 à 98 : résistance entre 10 et 20 ohm. (300 Hz)
  // <75 : résistance < 10 ohm. (2000 Hz)
  if (Tension_lue > 454) noTone(Sortie_SIGNAL); // R > 100 ohm.
  if ((Tension_lue < 455) && (Tension_lue > 327)) tone(Sortie_SIGNAL,50);
  if ((Tension_lue < 328) && (Tension_lue > 192)) tone(Sortie_SIGNAL,75);
  if ((Tension_lue < 193) && (Tension_lue > 98)) tone(Sortie_SIGNAL,300);
  if ((Tension_lue < 99) && (Tension_lue > 75)) tone(Sortie_SIGNAL,800);
  if (Tension_lue < 76) tone(Sortie_SIGNAL,2000); }
  //========================================================================
  noTone(Sortie_SIGNAL); N = 400;} // Restituer la valeur de départ.
  
void N_mesures_sur_Ai(byte ENTREE) { 
  N_Tensions_cumulees = 0;
  for (int I = 0; I < N ; I++) 
      {Tester_le_BP_A0(); // Pour détection dans la boucle de mesure.
       Tension_lue = analogRead(ENTREE); // Mesure analogique [0 à 1023].
       N_Tensions_cumulees = N_Tensions_cumulees + Tension_lue; }
  Tension_lue = N_Tensions_cumulees / N;
  Tension_lue = map(Tension_lue, 0, 1023, 0, 5000); // Tension en volts * 1000.
  if (Tension_lue == 5000) {Tension_lue = 4999.99;} }
  // 4999.99 au lieu de 5000 pour viter une division par zéro dans le calcul de R.

 // >>>>>>>>>>>>> Le B.P. est câblé en "Analogique" <<<<<<<<<<<<<<<<<<
void Tester_le_BP_A0() { // La lecture sur A0 donne 0 ou 930 maximum.
  int Numerisation_BP; // Valeur retournée par la CAN de A0.
  byte COMPTEUR; unsigned long Horloge_actuelle;
  Numerisation_BP = analogRead(0);
  if ((Numerisation_BP > 710) || (Numerisation_BP < 240)) {
    Clic_sur_le_BP = true; digitalWrite(LED_Arduino, HIGH);
    Augmenter_le_choix = false;
    Horloge_actuelle = millis(); Clic_long = false;
    if (Numerisation_BP > 710) { Augmenter_le_choix = true; }
    delay(100); // Attendre_la_stabilisation du travail.
    // Attendre_la_stabilisation du repos :
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; Numerisation_BP = analogRead(0);
      if ((Numerisation_BP > 710) || (Numerisation_BP < 240)) { COMPTEUR = 0; } }
    digitalWrite(LED_Arduino, LOW); // Éteindre la LED verte.
    if ((millis() - Horloge_actuelle) > 500) Clic_long = true; } }
  
