/* Programme d'expérimentation de pilotage d'un SERVOMOTEUR.
   En entrée de fonction le moteur va au neutre. (1500µS)
   NON court diminue "1" de 100µS avec butée à 200µS.
   NON long force le neutre à 1500µS.
   OUI court change augmente "1" de 100µS avec butée à 3000µS.
   OUI long fait sortir de cette fonction.      */
   
#define Sortie_SIGNAL 12 // Generation du signal étalon sur D12.
#define LED_Arduino 13 // LED verte sur le C.I.   
#define NB_tests_antirebonds 50 // Nombre de tests de stabilisation B.P.

// Variables utilisées.
byte Option_du_MENU; // Ordre de la fonction du MENU en cours.
boolean Clic_sur_le_BP, Augmenter_le_choix, Clic_long;
unsigned long CNA; // Mesure analogique retournée par le CNA.
// Type long pour homogénéité des variable dans le calcul de Duree_Pulse.
unsigned long Pulse_plus; // Impulsion positive mémorisée.
unsigned long Ancienne_valeur; // Fréquence mesurée.

void setup() {
  Serial.begin(115200);
  pinMode(Sortie_SIGNAL, OUTPUT);
  pinMode(LED_Arduino, OUTPUT); digitalWrite(LED_Arduino, LOW);}

void loop() {
  Fonction_pilotage_des_SERVOMOTEURS();
  Serial.println(); Serial.println("On vient d'en sortir.");
  Serial.println(); delay(1000);
  Serial.println("On y retourne !"); Serial.println(); }
  
void Fonction_pilotage_des_SERVOMOTEURS() {
  Pulse_plus = 1500; // Neutre. 
  Serial.println(); Serial.println("Pilotage de SERVOMOTEURS."); Serial.println();
  Clic_sur_le_BP = false; Clic_long = false; Augmenter_le_choix = false; 
  while (!(Augmenter_le_choix && Clic_long)) {
  //============================ Tant que non SORTIE ============================
   Piloter();
  //================ Traiter les B.P. =================
  Tester_le_BP_A0();
  if (Clic_sur_le_BP) {
     if ((Augmenter_le_choix) && (!Clic_long))
        { Clic_sur_le_BP = false;
          if (Pulse_plus < 3000) Pulse_plus = Pulse_plus + 100;}
     if (!Augmenter_le_choix)
        { Clic_sur_le_BP = false;
          if (Clic_long) Pulse_plus = 1500;
          else {if (Pulse_plus > 200) Pulse_plus = Pulse_plus - 100; } } } }
  //=============================================================================
  Option_du_MENU = 1; }
  
void Piloter() {
  //==================== PILOTER ======================
  digitalWrite(Sortie_SIGNAL, HIGH);
  delayMicroseconds(Pulse_plus);
  digitalWrite(Sortie_SIGNAL, LOW);
  delay(15); // Délai constant pour consommer 15mS.
  delayMicroseconds(5000 - Pulse_plus); // Ajustement pour une fréquence constante.
  //==================== AFFICHER =====================
  if (Pulse_plus != Ancienne_valeur) {
      Ancienne_valeur = Pulse_plus;
      Serial.println();
      Serial.print(" Travail = "); Serial.print(Pulse_plus);
      Afficher_microS();
      Serial.print(" Repos = "); Serial.print(20000 - Pulse_plus);
      Afficher_microS(); Serial.println();} }

void Afficher_microS() {Afficher_micro(); Serial.print("S"); }
  
void Afficher_micro() {Serial.print(" "); Serial.print(char(181));}

// >>>>>>>>>>>>> Le B.P. est câblé en "Analogique" <<<<<<<<<<<<<<<<<<
void Tester_le_BP_A0() { // La lecture sur A0 donne 0 ou 930 maximum.
  int Numerisation_BP; // Valeur retournée par la CAN de A0.
  byte COMPTEUR; unsigned long Horloge_actuelle;
  Numerisation_BP = analogRead(0);
  if ((Numerisation_BP > 710) || (Numerisation_BP < 240)) {
    Clic_sur_le_BP = true; digitalWrite(LED_Arduino, HIGH);
    Augmenter_le_choix = false;
    Horloge_actuelle = millis(); Clic_long = false;
    if (Numerisation_BP > 710) { Augmenter_le_choix = true; }
    delay(100); // Attendre_la_stabilisation du travail.
    // Attendre_la_stabilisation du repos :
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; Numerisation_BP = analogRead(0);
      if ((Numerisation_BP > 710) || (Numerisation_BP < 240)) { COMPTEUR = 0; } }
    digitalWrite(LED_Arduino, LOW); // Éteindre la LED verte.
    if ((millis() - Horloge_actuelle) > 500) Clic_long = true; } }
