/*  Multimètre aux fonctions étendues avec affichage sur la ligne série USB.
 A0 est reliée au bouton poussoir de sélection des fonctions.
 D11 est en sortie d'un signal PWM permanent. Fournit un signal carré de 490 Hz */

#define Entree_Frequencemetre 5 // Entrée D5 pour la mesure des fréquences.
#define Sortie_PWM 11

#define NB_tests_antirebonds 50 // Nombre de tests de stabilisation B.P.
#define NB_Options 4 // Options indexées entre 1 et 3.

#define N 400 // Nombre de mesures pour faire une moyenne.

#define LED_Arduino 13 // LED verte sur le C.I.

// Variables du programme.
boolean Clic_sur_le_BP, Augmenter_le_choix, Clic_long;
byte Option_du_MENU = 1; // Ordre de l'option en cours.
float Tension_lue, N_Tensions_cumulees, Valeur_calculee, Ancienne_Valeur ;
byte FONCTION = 1; // Fonction en cours.

void setup() {
  Serial.begin(115200);
  pinMode(LED_Arduino, OUTPUT); digitalWrite(LED_Arduino, LOW);
  Serial.println(); Serial.println("VOLTMETRE ETENDU."); Serial.println();
  analogWrite(Sortie_PWM,128);}

void loop() {
  Tester_le_BP_A0(); // Pour détection dans la boucle de base. 
  if (Clic_sur_le_BP) {
   // ===== Traiter la requête de l'un des deux B.P. =====
    Clic_sur_le_BP = false; // Action sur le B.P. prise en compte.
    // Traitement de l'option.
    if (Augmenter_le_choix)
         {Option_du_MENU++; if (Option_du_MENU > NB_Options) {Option_du_MENU = 1; } }
    else {Option_du_MENU--; if (Option_du_MENU == 0) {Option_du_MENU = NB_Options; } }
    if (Clic_long) { Option_du_MENU = 1; }
    Affiche_nature_Option_Indexee(); }
  // Traitement de routine de l'option active.
  switch(Option_du_MENU) {
    case 1 : {Mesure_les_TENSIONS(); 
              Valeur_calculee = map(Tension_lue, 0, 1021, 0, 5000);
              // Tension en volts * 1000. Valeur 1021 au lieu de 1023
              // pour compenser la 330kOhm du calibre 50Vcc.
              Affiche_les_TENSIONS(); break;}
    case 2 : {Mesure_les_TENSIONS();
              Valeur_calculee = map(Tension_lue, 0, 1021, 0, 5000);
              Affiche_les_TENSIONS(); break;}
    case 3 : {Mesure_les_TENSIONS();
              Valeur_calculee = map(Tension_lue, 0, 1021, 0, 3280); // 3280 pour 30v.
              if(Valeur_calculee < 3100) Affiche_les_TENSIONS(); // U < 31V.
              else Serial.println(" U > 30V changer de calibre."); break;}
    case 4 : {Mesure_les_TENSIONS();
              Valeur_calculee = map(Tension_lue, 0, 1021, 0, 5842); // 5842 pour 60v.
              if(Valeur_calculee > 2500) Affiche_les_TENSIONS(); // U < 25V.
              else Serial.println(" U < 30V changer de calibre.");} } }
    
void Mesure_les_TENSIONS() {
  N_Tensions_cumulees = 0;
  for (int I = 0; I < (N) ; I++) 
      {Tester_le_BP_A0(); // Pour détection dans la boucle de mesure.
       Tension_lue = analogRead(1); // Mesure analogique [0 à 1023].
       N_Tensions_cumulees = N_Tensions_cumulees + Tension_lue; }
  Tension_lue = N_Tensions_cumulees / N;}     

void Affiche_les_TENSIONS() {     
  if (Valeur_calculee != Ancienne_Valeur) {    
      Ancienne_Valeur = Valeur_calculee;
      switch(Option_du_MENU) {
          case 1 : {Serial.print("Tension lue sur E = ");
                    Serial.println(Valeur_calculee/1000); break;}
          case 2 : {Serial.print("Tension lue sur 50Vcc = ");
                    Serial.println(Valeur_calculee/100,1); break;}
          case 3 : {Serial.print("Alternatif (3 a 30V) = ");
                    Serial.println(Valeur_calculee/100,1); break;}
          case 4 : {Serial.print("Alternatif (30 a 60V) = ");
                    Serial.println(Valeur_calculee/100,1);} } } }

void Affiche_nature_Option_Indexee() {
    Serial.println();
    switch(Option_du_MENU) {
      case 1 : {Affiche_titre_Vmetre(); Serial.println("Vcc."); break;}
      case 2 : {Affiche_titre_Vmetre(); Serial.println("0Vcc."); break;}
      default : Serial.println("V alternatif.");} }
                
void Affiche_titre_Vmetre() {
  Serial.print("Voltm"); Serial.print(char(232)); Serial.print("tre 0 a 5"); }

// >>>>>>>>>>>>> Le B.P. est câblé en "Analogique" <<<<<<<<<<<<<<<<<<
void Tester_le_BP_A0() { // La lecture sur A0 donne 0 ou 930 maximum.
  int Numerisation_BP; // Valeur retournée par la CAN de A0.
  byte COMPTEUR; unsigned long Horloge_actuelle;
  Numerisation_BP = analogRead(0);
  if ((Numerisation_BP > 710) || (Numerisation_BP < 240)) {
    Clic_sur_le_BP = true; digitalWrite(LED_Arduino, HIGH);
    Augmenter_le_choix = false;
    Horloge_actuelle = millis(); Clic_long = false;
    if (Numerisation_BP > 710) { Augmenter_le_choix = true; }
    delay(100); // Attendre_la_stabilisation du travail.
    // Attendre_la_stabilisation du repos :
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; Numerisation_BP = analogRead(0);
      if ((Numerisation_BP > 710) || (Numerisation_BP < 240)) { COMPTEUR = 0; } }
    digitalWrite(LED_Arduino, LOW); // Éteindre la LED verte.
    if ((millis() - Horloge_actuelle) > 500) Clic_long = true; } }
  

  
   
